3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE
='[-v] [--onto <newbase>] <upstream> [<branch>]'
7 LONG_USAGE
='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .dotest working files, use the command
18 git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used. You must be in the top
22 directory of your project to start (or continue) a rebase.
24 Example: git-rebase master~1 topic
26 A---B---C topic A'\''--B'\''--C'\'' topic
28 D---E---F---G master D---E---F---G master
33 set_reflog_action rebase
38 When you have resolved this problem run \"git rebase --continue\".
39 If you would prefer to skip this patch, instead run \"git rebase --skip\".
40 To restore the original branch and stop rebasing run \"git rebase --abort\".
45 dotest
=$GIT_DIR/.dotest-merge
51 test -n "$prev_head" || die
"prev_head must be defined"
52 test -d "$dotest" || die
"$dotest directory does not exist"
54 unmerged
=$
(git-ls-files
-u)
55 if test -n "$unmerged"
57 echo "You still have unmerged paths in your index"
58 echo "did you forget update-index?"
62 if test -n "`git-diff-index HEAD`"
64 if ! git-commit
-C "`cat $dotest/current`"
66 echo "Commit failed, please do not call \"git commit\""
67 echo "directly, but instead do one of the following: "
70 printf "Committed: %0${prec}d" $msgnum
72 printf "Already applied: %0${prec}d" $msgnum
74 echo ' '`git-rev-list --pretty=oneline -1 HEAD | \
75 sed 's/^[a-f0-9]\+ //'`
77 prev_head
=`git-rev-parse HEAD^0`
78 # save the resulting commit so we can read-tree on it later
79 echo "$prev_head" > "$dotest/prev_head"
81 # onto the next patch:
82 msgnum
=$
(($msgnum + 1))
83 echo "$msgnum" >"$dotest/msgnum"
87 cmt
="$(cat $dotest/cmt.$1)"
88 echo "$cmt" > "$dotest/current"
89 hd
=$
(git-rev-parse
--verify HEAD
)
90 cmt_name
=$
(git-symbolic-ref HEAD
)
91 msgnum
=$
(cat $dotest/msgnum
)
92 end
=$
(cat $dotest/end
)
93 eval GITHEAD_
$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
94 eval GITHEAD_
$hd='"$(cat $dotest/onto_name)"'
95 export GITHEAD_
$cmt GITHEAD_
$hd
96 git-merge-
$strategy "$cmt^" -- "$hd" "$cmt"
100 unset GITHEAD_
$cmt GITHEAD_
$hd
104 test -d "$GIT_DIR/rr-cache" && git-rerere
108 echo "Strategy: $rv $strategy failed, try another" 1>&2
112 die
"Unknown exit code ($rv) from command:" \
113 "git-merge-$strategy $cmt^ -- HEAD $cmt"
123 while case "$#" in 0) break ;; esac
127 diff=$
(git-diff-files
)
129 ?
*) echo "You must edit all merge conflicts and then"
130 echo "mark them as resolved using git update-index"
136 prev_head
="`cat $dotest/prev_head`"
137 end
="`cat $dotest/end`"
138 msgnum
="`cat $dotest/msgnum`"
139 onto
="`cat $dotest/onto`"
141 while test "$msgnum" -le "$end"
149 git am
--resolved --3way --resolvemsg="$RESOLVEMSG"
155 if test -d "$GIT_DIR/rr-cache"
159 prev_head
="`cat $dotest/prev_head`"
160 end
="`cat $dotest/end`"
161 msgnum
="`cat $dotest/msgnum`"
162 msgnum
=$
(($msgnum + 1))
163 onto
="`cat $dotest/onto`"
164 while test "$msgnum" -le "$end"
172 git am
-3 --skip --resolvemsg="$RESOLVEMSG"
176 if test -d "$GIT_DIR/rr-cache"
187 die
"No rebase in progress?"
189 git
reset --hard ORIG_HEAD
193 test 2 -le "$#" || usage
197 -M|
-m|
--m|
--me|
--mer|
--merg|
--merge)
200 -s=*|
--s=*|
--st=*|
--str=*|
--stra=*|
--strat=*|
--strate=*|\
201 --strateg=*|
--strategy=*|\
202 -s|
--s|
--st|
--str|
--stra|
--strat|
--strate|
--strateg|
--strategy)
205 strategy
=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
231 # Make sure we do not have .dotest
232 if test -z "$do_merge"
239 It seems that I cannot create a .dotest directory, and I wonder if you
240 are in the middle of patch application or another rebase. If that is not
241 the case, please rm -fr .dotest and run me again. I am stopping in case
242 you still have something valuable there.'
248 die
"previous dotest directory $dotest still exists." \
249 'try git-rebase < --continue | --abort >'
253 # The tree must be really really clean.
254 git-update-index
--refresh ||
exit
255 diff=$
(git-diff-index
--cached --name-status -r HEAD
)
257 ?
*) echo "cannot rebase: your index is not up-to-date"
263 # The upstream head must be given. Make sure it is valid.
265 upstream
=`git rev-parse --verify "${upstream_name}^0"` ||
266 die
"invalid upstream $upstream_name"
268 # If a hook exists, give it a chance to interrupt
269 if test -x "$GIT_DIR/hooks/pre-rebase"
271 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
{
272 echo >&2 "The pre-rebase hook refused to rebase."
277 # If the branch to rebase is given, first switch to it.
281 git-checkout
"$2" || usage
284 if branch_name
=`git symbolic-ref -q HEAD`
286 branch_name
=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
288 branch_name
=HEAD
;# detached
292 branch
=$
(git-rev-parse
--verify "${branch_name}^0") ||
exit
294 # Make sure the branch to rebase onto is valid.
295 onto_name
=${newbase-"$upstream_name"}
296 onto
=$
(git-rev-parse
--verify "${onto_name}^0") ||
exit
298 # Now we are rebasing commits $upstream..$branch on top of $onto
300 # Check if we are already based on $onto, but this should be
301 # done only when upstream and onto are the same.
302 mb
=$
(git-merge-base
"$onto" "$branch")
303 if test "$upstream" = "$onto" && test "$mb" = "$onto"
305 echo >&2 "Current branch $branch_name is up to date."
309 if test -n "$verbose"
311 echo "Changes from $mb to $onto:"
312 git-diff-tree
--stat --summary "$mb" "$onto"
315 # Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
316 echo "First, rewinding head to replay your work on top of it..."
317 git-reset
--hard "$onto"
319 # If the $onto is a proper descendant of the tip of the branch, then
320 # we just fast forwarded.
321 if test "$mb" = "$branch"
323 echo >&2 "Fast-forwarded $branch_name to $onto_name."
327 if test -z "$do_merge"
329 git-format-patch
-k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
330 git am
$git_am_opt --binary -3 -k --resolvemsg="$RESOLVEMSG"
334 # start doing a rebase with git-merge
335 # this is rename-aware if the recursive (default) strategy is used
338 echo "$onto" > "$dotest/onto"
339 echo "$onto_name" > "$dotest/onto_name"
340 prev_head
=`git-rev-parse HEAD^0`
341 echo "$prev_head" > "$dotest/prev_head"
344 for cmt
in `git-rev-list --no-merges "$upstream"..ORIG_HEAD \
345 | @@PERL@@ -e 'print reverse <>'`
347 msgnum
=$
(($msgnum + 1))
348 echo "$cmt" > "$dotest/cmt.$msgnum"
351 echo 1 >"$dotest/msgnum"
352 echo $msgnum >"$dotest/end"
357 while test "$msgnum" -le "$end"